︠63bf64df-fd09-4e41-841b-2f45a8adc3a8︠
def trace_algo(cmd):
    sort_gen = iter(cmd)
    def bla(cmd=selector(["Step"], 
                       buttons=True)):
        global dessin
        try:
            mess, dessin = sort_gen.next()
        except StopIteration:
            mess = "======== Finished ======="
        print mess
        dessin.show(figsize=(8,6))
    interact(bla)
︡abe78342-1635-406c-b0cc-cfc04d01eafb︡︡
︠f73e9c07-159d-45a4-bd96-db6f7dd59504︠
def plot_tab(tab):
    return sum(point(v, size=50) for v in
                enumerate(tab))
︡82377b0c-489c-4fd0-82d5-c7452662b9b8︡︡
︠00902c38-3dbc-4ead-85b7-e5ccd823af36︠
def vert(i, tab, **opts):
    return line([(i, 0),(i, max(tab)+1)], **opts)
︡3a02cdbe-c8ef-4077-8df9-1dc6533d891a︡︡
︠1a46a991-117f-4bb3-b8ad-2685032e4331︠
def horiz(i, tab, **opts):
    return line([(0,i),(len(tab)+1,i)], **opts)
︡2c7a4f3b-dd35-4a02-a538-7a29364510c1︡︡
︠2fdff0c3-5aa3-4f27-bf38-d2ca7af226b4i︠
%html
<h1 style="text-align: center;"><strong>Bubble Sort</strong></h1>

︡57039268-1c5e-408a-871c-c5844a5ae73c︡{"html": "<h1 style=\"text-align: center;\"><strong>Bubble Sort</strong></h1>"}︡
︠bfb2e53f-0060-4aff-aba3-4ecb06882fbd︠
def bubble_sort(T):
    def dessin():
        return ("i=%i, j=%i"%(i,j), 
           sum(point((pos,v), size=50, 
                color="blue" if pos <= i else "green")
               for pos, v in enumerate(tab))
            +vert(i+1/2,tab,color="green")
            +vert(j+1/2,tab))
    yield "Start", plot_tab(T)
    for i in range(len(T)-1, 0, -1):
        for j in range(i):
            if T[j] > T[j+1]:
                T[j], T[j+1] = T[j+1], T[j]  
            yield dessin()
︡8612da62-1baf-4156-87ce-1467e269fff7︡︡
︠ceaa5337-4d3f-4595-be34-bd1d3aaefc3c︠
tab = [randint(0, 20) for i in range(10)]
trace_algo(bubble_sort(tab))
︡a75e033a-013a-41ec-9cfe-0b2d32d2e285︡{"html": "<!--notruncate-->\n        <div padding=6 id=\"div-interact-20\">\n          <table width=800px height=20px bgcolor=\"#c5c5c5\" cellpadding=15>\n            <tr>\n              <td bgcolor=\"#f9f9f9\" valign=top align=left>\n            <table>\n              <tr><td colspan=3><table><tr><td align=right><font color=\"black\">cmd&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:outset;\" value=\"0\" onclick=\"interact(20, {variable: 'cmd', adapt_number: 1, value: encode64(this.value)}, 1)\">Step</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n              <tr><td></td><td style='width: 100%;'>\n        <div id=\"cell-interact-20\"><?__SAGE__START>\n          <table border=0 bgcolor=\"white\" width=100%>\n            <tr>\n              <td bgcolor=\"white\" align=left valign=top>\n                <pre><?__SAGE__TEXT></pre>\n              </td>\n            </tr>\n            <tr>\n              <td align=left valign=top><?__SAGE__HTML></td>\n            </tr>\n          </table><?__SAGE__END>\n        </div></td><td></td></tr>\n              <tr><td colspan=3></td></tr>\n            </table></td>\n            </tr>\n          </table>\n        </div>"}︡
︠006f006c-70ff-4042-b4e7-5905f72759a0i︠
%html
<h1 style="text-align: center;"><strong>Insert Sort</strong></h1>
<p><strong><br /></strong></p>

︡e248cc35-901e-4c8c-9d87-276a07434fab︡{"html": "<h1 style=\"text-align: center;\"><strong>Insert Sort</strong></h1>\n<p><strong><br /></strong></p>"}︡
︠f1818d81-24ca-48e5-9a62-c88c5d7592e4︠
def insert_sort(T):
    def dessin():
        return ("i=%i, j=%i, e=%i"%(i,j,e), 
            plot_tab(T)+vert(j, tab)+horiz(e, tab))
    yield "Start", plot_tab(T)
    for i in range(1,len(T)):
        e = T[i]
        j = i
        yield dessin()
        while j>0 and T[j-1] > e:
            T[j] = T[j-1]
            j -= 1
            yield dessin()
        T[j] = e
        yield dessin()
︡493353e0-bf49-4107-96cd-d7ba685c5f2a︡︡
︠317a35ca-bc5c-4047-9fed-df3b568fa28d︠
tab = [randint(0, 20) for i in range(10)]
trace_algo(insert_sort(tab))
︡c39f3322-2c20-4786-9c57-49f00ab6f5d2︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-19\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table>\n<tr><td colspan=3><table><tr><td align=right><font color=\"black\">cmd&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:outset;\" value=\"0\" onclick=\"interact(19, '_interact_.update(\\'19\\', \\'cmd\\', 15, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'19\\');')\">Step</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n<tr><td></td><td style='width: 100%;'><div id=\"cell-interact-19\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td><td></td></tr>\n<tr><td colspan=3></td></tr>\n</table></td>\n                 </tr></table></div>\n                 "}︡
︠27d2c91d-9f13-461b-9712-0d7a5e07c99di︠
%html
<h1 style="text-align: center;"><strong>Partitioning</strong></h1>

<h2>Left to right method</h2>

︡acf3f8d9-02ac-41a0-a9d9-4edeefab48a3︡{"html": "<h1 style=\"text-align: center;\"><strong>Partitioning</strong></h1>\n\n<h2>Left to right method</h2>"}︡
︠3b73d5dc-5b04-42f0-b6a4-17e6967b0cac︠
def partition(Tab, P):
    c = 0; j = 0    
    def dessin():
        return (sum(point((i,v), size=40, 
                   color="green" if P(v) else "red") 
            for i,v in enumerate(tab)) 
            + vert(c, Tab, color="green") + vert(j, Tab))
    yield "Start", dessin()
    c = 0
    while c < len(Tab) and P(Tab[c]):
        c +=1
    yield   "c=%i"%c, dessin()+vert(c,Tab,color= "green")
    for j in range(c+1, len(Tab)):
        yield ("c=%i, j=%i"%(c, j), dessin())
        if P(Tab[j]):
            Tab[c], Tab[j] = Tab[j], Tab[c]
            c +=1        
            yield ("c=%i, j=%i"%(c, j), dessin())
    yield ("Retour %i"%c, 
        dessin()+vert(c-1/2, Tab, color="blue"))
︡da36c869-d74f-432e-8623-333e816ca034︡︡
︠0b80eb5d-2379-4306-8e92-12e81d3d071b︠
tab = [randint(0, 20) for i in range(20)]
tab = [1]+[2]*15
trace_algo(partition(tab, lambda x: x % 2 == 0))
︡c251ffe3-db32-4abb-a29c-b6385966b8b2︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-8\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table>\n<tr><td colspan=3><table><tr><td align=right><font color=\"black\">cmd&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:outset;\" value=\"0\" onclick=\"interact(8, '_interact_.update(\\'8\\', \\'cmd\\', 7, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'8\\');')\">Step</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n<tr><td></td><td style='width: 100%;'><div id=\"cell-interact-8\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td><td></td></tr>\n<tr><td colspan=3></td></tr>\n</table></td>\n                 </tr></table></div>\n                 "}︡
︠7e5fc170-1c31-49a5-8cae-791b05313677i︠
%html
<h2>Double sided method</h2>

︡73fd6cf1-719b-42d5-9c49-3c5eb3c8fa53︡{"html": "<h2>Double sided method</h2>"}︡
︠8fa4af44-0e00-4a8e-a1e2-cc13748f421e︠
def partition2(Tab, P): 
    def dessin():
        return (sum(point((i,v), size=40, 
                   color="green" if P(v) else "red") 
            for i,v in enumerate(tab)) 
            + vert(i, Tab, color="green")
            + vert(j, Tab, color="red"))
            
    i = 0
    j = len(Tab)-1
    yield         "Start", dessin()
    while i < j:
        while P(Tab[i]): i += 1
        while not P(Tab[j]): j -= 1
        yield      "i=%i, j=%i"%(i, j), dessin()
        if i<j:
            Tab[i], Tab[j] = Tab[j], Tab[i]
            yield "i=%i, j=%i"%(i, j), dessin()
            i += 1; j -= 1
    yield         ("Retour %i"%(i-1), 
            dessin() + vert(i-1/2, Tab, color="blue"))
︡5ac71dd5-3c43-4641-9eac-dec68bd124c1︡︡
︠816c22db-48c9-4210-a5c9-1dad5831afb5︠
tab = [randint(0, 20) for i in range(20)]
trace_algo(partition2(tab, lambda x: x % 2 == 0))
︡7658c628-789b-4f30-bdca-b708c1d90d4f︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-11\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table>\n<tr><td colspan=3><table><tr><td align=right><font color=\"black\">cmd&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:outset;\" value=\"0\" onclick=\"interact(11, '_interact_.update(\\'11\\', \\'cmd\\', 8, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'11\\');')\">Step</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n<tr><td></td><td style='width: 100%;'><div id=\"cell-interact-11\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td><td></td></tr>\n<tr><td colspan=3></td></tr>\n</table></td>\n                 </tr></table></div>\n                 "}︡
︠57d6f1dd-8de6-481f-934e-779fd3522efei︠
%html
<h1 style="text-align: center;">Quick Sort</h1>

︡5928472d-db93-4478-a543-28a4f8c1f0c0︡{"html": "<h1 style=\"text-align: center;\">Quick Sort</h1>"}︡
︠10552002-2350-4c5e-a3cf-6d91ae645335︠
def quicksort(tab, min, max):
    
    def dessin():
        return(
           "min = %i, max=%i, pivot=%i, i=%i, j=%i"%(
                min, max, pivot, i, j),
            sum(point((pos,v), size=40, 
                color = 
                     "blue" if pos < min or pos > max
                     else 
                     "red" if v > pivot 
                     else 
                     "green") 
            for pos,v in enumerate(tab)) 
            + vert(i, tab, color="black")
            # + vert(j, tab, color="blue")
            + vert(min, tab, color="blue")
            + vert(max, tab, color="blue") 
            + horiz(pivot, tab))
                
    if min < max:
        pivot = tab[max]
        i = min
        j = max-1
        yield dessin()
        while True:
            while tab[i] < pivot: i +=1
            while tab[j] > pivot: j -=1
            if i < j:
                tab[i], tab[j] = tab[j], tab[i]
                i += 1; j -= 1
            else:
                tab[i], tab[max] = tab[max], tab[i]
                break
        yield dessin()
        for step in quicksort(tab, min, i-1): 
            yield step
        for step in quicksort(tab, i+1, max): 
            yield step
︡a2cba439-702f-4fb1-939e-dce7df1665b0︡︡
︠1e99cecc-fc00-4f84-8e1d-8b0c1a0f1d4c︠
tab = [randint(0, 20) for i in range(15)]
print tab
for step in quicksort(tab, 0, len(tab)-1):
    pass
tab
︡51bda48e-6549-495d-b3a8-49f6c36fb599︡{"stdout": "[9, 1, 2, 0, 8, 14, 13, 13, 13, 18, 8, 19, 17, 17, 12]\n[0, 1, 2, 8, 8, 9, 12, 13, 13, 13, 14, 17, 17, 18, 19]"}︡
︠dbd6b79d-c6f9-410a-90ef-fd337b7a4d98︠
tab = [randint(0, 20) for i in range(20)]
trace_algo(quicksort(tab, 0, len(tab)-1))
︡9f048c1b-441a-4fef-ac2a-39e383c679c9︡{"html": "<!--notruncate-->\n        <div padding=6 id=\"div-interact-35\">\n          <table width=800px height=20px bgcolor=\"#c5c5c5\" cellpadding=15>\n            <tr>\n              <td bgcolor=\"#f9f9f9\" valign=top align=left>\n            <table>\n              <tr><td colspan=3><table><tr><td align=right><font color=\"black\">cmd&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:outset;\" value=\"0\" onclick=\"interact(35, {variable: 'cmd', adapt_number: 2, value: encode64(this.value)}, 1)\">Step</button>\n</td></tr></table></td>\n</tr></table></td></tr>\n              <tr><td></td><td style='width: 100%;'>\n        <div id=\"cell-interact-35\"><?__SAGE__START>\n          <table border=0 bgcolor=\"white\" width=100%>\n            <tr>\n              <td bgcolor=\"white\" align=left valign=top>\n                <pre><?__SAGE__TEXT></pre>\n              </td>\n            </tr>\n            <tr>\n              <td align=left valign=top><?__SAGE__HTML></td>\n            </tr>\n          </table><?__SAGE__END>\n        </div></td><td></td></tr>\n              <tr><td colspan=3></td></tr>\n            </table></td>\n            </tr>\n          </table>\n        </div>"}︡
